package org.nuiton.topia.security.entities.user;

import java.util.Collection;
import org.nuiton.topia.persistence.TopiaEntity;
import org.nuiton.topia.security.listener.NoSecurityLoad;

public interface TopiaUser extends NoSecurityLoad, TopiaEntity {

    String LOGIN = "login";

    String EMAIL = "email";

    String PASSWORD = "password";

    String NOTE = "note";

    String LINK_APPLICATION = "linkApplication";

    String TOPIA_GROUP = "topiaGroup";

    void setLogin(String login);

    String getLogin();

    void setEmail(String email);

    String getEmail();

    void setPassword(String password);

    String getPassword();

    void setNote(String note);

    String getNote();

    void setLinkApplication(String linkApplication);

    String getLinkApplication();

    void addTopiaGroup(TopiaGroup topiaGroup);

    void addAllTopiaGroup(Collection<TopiaGroup> topiaGroup);

    void setTopiaGroup(Collection<TopiaGroup> topiaGroup);

    void removeTopiaGroup(TopiaGroup topiaGroup);

    void clearTopiaGroup();

    Collection<TopiaGroup> getTopiaGroup();

    TopiaGroup getTopiaGroupByTopiaId(String topiaId);

    int sizeTopiaGroup();

    boolean isTopiaGroupEmpty();

    boolean checkPassword(String password);

    void setPassword(String oldPassword, String newPassword);

} //TopiaUser
